<?php

/**
 * genera_bogota actions.
 *
 * @package    nomina
 * @subpackage genera_bogota
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class genera_bogotaActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by NUM_DOC';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $periodo_filtro = $request['id_periodo_filtro'];
            $periodo = $request['id_periodo'];

            /*
             * Variables opcionales
             */
            //funcionario
            if (isset($request['num_doc'])) {
                $whereFuncionarioNumDoc = " AND tab0.num_doc = " . $request['num_doc'];
            } else {
                $whereFuncionarioNumDoc = ' ';
            }
            //funcionario
            if (isset($request['id_tipo_doc'])) {
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            } else {
                $whereFuncionarioTipoDoc = ' ';
            }
            //whereBanco
            if (isset($request['id_bn'])) {
                $whereBanco = " AND tab0.id_bn = " . $request['id_bn'];
            } else {
                $whereBanco = ' ';
            }
            //Tipo Cuenta
            if (isset($request['tipo_cuenta'])) {
                $whereTipoCuenta = " AND tab0.tipo_cuenta = " . $request['tipo_cuenta'];
            } else {
                $whereTipoCuenta = ' ';
            }

            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            /*
             * Se agrega campo pago_func para tenerlo en cuenta en el calculo del neto a pagar - 20130731
             * Validacion para no traer las personas retiradas en fechas anteriores al nuevo periodo - 20141202
             * Se cambia la validacion para los datos del banco, si la persona esta retirada trae el ultimo registro por fecha y estado de no_pago_func  - 20150226
             */
            $sql = <<<EOD
select count(*) as count from (

select 
tab0.* ,
(select distinct periodo.periodo from no_periodo_v periodo where periodo.id_periodo = $periodo_filtro) AS PERIODO


from(

    SELECT NUM_DOC,NOMBRE_APELLIDO,BANCO,CODIGO_ACH,NUM_CUENTA,DESCRIPCION,ID_PERIODO,SUM(NVL(VALOR,0)) AS VALOR, id_tipo_doc, id_bn, id as tipo_cuenta
    
    FROM(
    
        select tab1.num_doc,tab6.nombre_apellido,tab3.codigo||' '||tab3.descripcion AS BANCO, tab3.codigo_ach, tab2.num_cuenta, tab4.descripcion,
        case when tab5.operador = 1 then tab1.valor_liquidado else (tab1.valor_liquidado * -1) end as valor,
        tab1.id_periodo,
        tab1.id_tipo_doc, tab3.id_bn, tab4.id
        from no_liquida_nomina tab1
        left join no_concep_nomina tab5 ON tab5.id_concep_nomina = tab1.id_concep_nomina
        left join no_datos_funcionario_v tab6  ON tab6.id_tipo_doc = tab1.id_tipo_doc and tab6.num_doc = tab1.num_doc
        
        --join no_pago_func tab2 ON tab2.id_tipo_doc = tab1.id_tipo_doc and tab2.num_doc = tab1.num_doc
        left join (
            SELECT
             aut.*,
             ROW_NUMBER() OVER (
              partition by aut.num_doc
              ORDER BY aut.estado desc, aut.fecha_activacion desc
             ) AS rn
            from no_pago_func aut
        )tab2 ON tab2.id_tipo_doc = tab1.id_tipo_doc and tab2.num_doc = tab1.num_doc
        and tab2.rn = 1
        left join no_nombramiento_v tab7  ON tab7.id_tipo_doc = tab1.id_tipo_doc and tab7.num_doc = tab1.num_doc
        
        join ts_bn tab3 ON tab3.id_bn = tab2.id_bn
        join ts_tc tab4 ON tab4.id = tab2.tipo_cuenta
        
        where 
        tab5.pago_func = 1
        and (
            tab2.estado = 1
            or
            (
                tab2.estado = 0 and tab7.estado = 0 and tab2.fecha_terminacion <= tab7.fecha_termina
            )
        )
    
    )
    group by num_doc,nombre_apellido,banco,codigo_ach,num_cuenta,descripcion,id_periodo, id_tipo_doc, id_bn, id

)tab0

where tab0.id_periodo = $periodo_filtro
$whereFuncionarioNumDoc
$whereFuncionarioTipoDoc
$whereBanco $whereTipoCuenta

and tab0.NUM_DOC not in (
 select nom.NUM_DOC from no_nombramiento_v nom 
  where nom.fecha_retiro is not null
  and (select no_periodo.fecha_ini from no_periodo 
        where id_periodo = $periodo_filtro) > trunc(last_day( nom.fecha_termina ))
) 
    
)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];

            /*
             * Se agrega campo pago_func para tenerlo en cuenta en el calculo del neto a pagar - 20130731
             * Validacion para no traer las personas retiradas en fechas anteriores al nuevo periodo - 20141202
             * Se cambia la validacion para los datos del banco, si la persona esta retirada trae el ultimo registro por fecha y estado de no_pago_func  - 20150226
             */
            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

select 
tab0.* ,
(select distinct periodo.periodo from no_periodo_v periodo where periodo.id_periodo = $periodo_filtro) AS PERIODO


from(

    SELECT NUM_DOC,NOMBRE_APELLIDO,BANCO,CODIGO_ACH,NUM_CUENTA,DESCRIPCION,ID_PERIODO,SUM(NVL(VALOR,0)) AS VALOR, id_tipo_doc, id_bn, id as tipo_cuenta
    
    FROM(
    
        select tab1.num_doc,tab6.nombre_apellido,tab3.codigo||' '||tab3.descripcion AS BANCO, tab3.codigo_ach, tab2.num_cuenta, tab4.descripcion,
        case when tab5.operador = 1 then tab1.valor_liquidado else (tab1.valor_liquidado * -1) end as valor,
        tab1.id_periodo,
        tab1.id_tipo_doc, tab3.id_bn, tab4.id
        from no_liquida_nomina tab1
        left join no_concep_nomina tab5 ON tab5.id_concep_nomina = tab1.id_concep_nomina
        left join no_datos_funcionario_v tab6  ON tab6.id_tipo_doc = tab1.id_tipo_doc and tab6.num_doc = tab1.num_doc
        
        --join no_pago_func tab2 ON tab2.id_tipo_doc = tab1.id_tipo_doc and tab2.num_doc = tab1.num_doc
        left join (
            SELECT
             aut.*,
             ROW_NUMBER() OVER (
              partition by aut.num_doc
              ORDER BY aut.estado desc, aut.fecha_activacion desc
             ) AS rn
            from no_pago_func aut
        )tab2 ON tab2.id_tipo_doc = tab1.id_tipo_doc and tab2.num_doc = tab1.num_doc
        and tab2.rn = 1
        left join no_nombramiento_v tab7  ON tab7.id_tipo_doc = tab1.id_tipo_doc and tab7.num_doc = tab1.num_doc
        
        join ts_bn tab3 ON tab3.id_bn = tab2.id_bn
        join ts_tc tab4 ON tab4.id = tab2.tipo_cuenta
        
        where 
        tab5.pago_func = 1
        and (
            tab2.estado = 1
            or
            (
                tab2.estado = 0 and tab7.estado = 0 and tab2.fecha_terminacion <= tab7.fecha_termina
            )
        )
    
    )
    group by num_doc,nombre_apellido,banco,codigo_ach,num_cuenta,descripcion,id_periodo, id_tipo_doc, id_bn, id

)tab0

where tab0.id_periodo = $periodo_filtro
$whereFuncionarioNumDoc
$whereFuncionarioTipoDoc
$whereBanco $whereTipoCuenta

and tab0.NUM_DOC not in (
 select nom.NUM_DOC from no_nombramiento_v nom 
  where nom.fecha_retiro is not null
  and (select no_periodo.fecha_ini from no_periodo 
        where id_periodo = $periodo_filtro) > trunc(last_day( nom.fecha_termina ))
)    
                    
$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[inf_pago_cheque] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

    /**
     * Metodo para sumar 
     *
     * @param sfWebRequest $request
     */
    public function executeSum(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by id_tipo_doc, num_doc ';
        }

        //manejo de errores
        try {
            /*
             * Variables obligatorias
             */
            $periodo_filtro = $request['id_periodo_filtro'];
            $periodo = $request['id_periodo'];

            /*
             * Variables opcionales
             */
            //funcionario
            if (isset($request['num_doc'])) {
                $whereFuncionarioNumDoc = " AND tab0.num_doc = " . $request['num_doc'];
            } else {
                $whereFuncionarioNumDoc = ' ';
            }
            //funcionario
            if (isset($request['id_tipo_doc'])) {
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            } else {
                $whereFuncionarioTipoDoc = ' ';
            }
            //whereBanco
            if (isset($request['id_bn'])) {
                $whereBanco = " AND tab0.id_bn = " . $request['id_bn'];
            } else {
                $whereBanco = ' ';
            }
            //Tipo Cuenta
            if (isset($request['tipo_cuenta'])) {
                $whereTipoCuenta = " AND tab0.tipo_cuenta = " . $request['tipo_cuenta'];
            } else {
                $whereTipoCuenta = ' ';
            }

            /*
             * Se agrega campo pago_func para tenerlo en cuenta en el calculo del neto a pagar - 20130731
             * Validacion para no traer las personas retiradas en fechas anteriores al nuevo periodo - 20141202
             * Se cambia la validacion para los datos del banco, si la persona esta retirada trae el ultimo registro por fecha y estado de no_pago_func  - 20150226
             */
            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT

'Totales: ' || count(*) as num_doc,
SUM(VALOR)  as VALOR

FROM (  

select 
tab0.* ,
(select distinct periodo.periodo from no_periodo_v periodo where periodo.id_periodo = $periodo_filtro) AS PERIODO


from(

    SELECT NUM_DOC,NOMBRE_APELLIDO,BANCO,CODIGO_ACH,NUM_CUENTA,DESCRIPCION,ID_PERIODO,SUM(NVL(VALOR,0)) AS VALOR, id_tipo_doc, id_bn, id as tipo_cuenta
    
    FROM(
    
        select tab1.num_doc,tab6.nombre_apellido,tab3.codigo||' '||tab3.descripcion AS BANCO, tab3.codigo_ach, tab2.num_cuenta, tab4.descripcion,
        case when tab5.operador = 1 then tab1.valor_liquidado else (tab1.valor_liquidado * -1) end as valor,
        tab1.id_periodo,
        tab1.id_tipo_doc, tab3.id_bn, tab4.id
        from no_liquida_nomina tab1
        left join no_concep_nomina tab5 ON tab5.id_concep_nomina = tab1.id_concep_nomina
        left join no_datos_funcionario_v tab6  ON tab6.id_tipo_doc = tab1.id_tipo_doc and tab6.num_doc = tab1.num_doc
        
        --join no_pago_func tab2 ON tab2.id_tipo_doc = tab1.id_tipo_doc and tab2.num_doc = tab1.num_doc
        left join (
            SELECT
             aut.*,
             ROW_NUMBER() OVER (
              partition by aut.num_doc
              ORDER BY aut.estado desc, aut.fecha_activacion desc
             ) AS rn
            from no_pago_func aut
        )tab2 ON tab2.id_tipo_doc = tab1.id_tipo_doc and tab2.num_doc = tab1.num_doc
        and tab2.rn = 1
        left join no_nombramiento_v tab7  ON tab7.id_tipo_doc = tab1.id_tipo_doc and tab7.num_doc = tab1.num_doc
        
        join ts_bn tab3 ON tab3.id_bn = tab2.id_bn
        join ts_tc tab4 ON tab4.id = tab2.tipo_cuenta
        
        where 
        tab5.pago_func = 1
        and (
            tab2.estado = 1
            or
            (
                tab2.estado = 0 and tab7.estado = 0 and tab2.fecha_terminacion <= tab7.fecha_termina
            )
        )
    
    )
    group by num_doc,nombre_apellido,banco,codigo_ach,num_cuenta,descripcion,id_periodo, id_tipo_doc, id_bn, id

)tab0

where tab0.id_periodo = $periodo_filtro
$whereFuncionarioNumDoc
$whereFuncionarioTipoDoc
$whereBanco $whereTipoCuenta

and tab0.NUM_DOC not in (
 select nom.NUM_DOC from no_nombramiento_v nom 
  where nom.fecha_retiro is not null
  and (select no_periodo.fecha_ini from no_periodo 
        where id_periodo = $periodo_filtro) > trunc(last_day( nom.fecha_termina ))
) 
    
$sortBy

)
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);

            $this->totalRows = count($resultado);
            $this->startRow = 0;
            $this->endRow = count($resultado);
            $this->list_data = $resultado;
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
